Index: trunk/src/world_entities/space_ships/space_ship.h
===================================================================
--- trunk/src/world_entities/space_ships/space_ship.h	(revision 10697)
+++ trunk/src/world_entities/space_ships/space_ship.h	(revision 10698)
@@ -12,4 +12,5 @@
 #include "playable.h"
 #include "extendable.h"
+#include "world_entity.h"
 
 // Forward Declaration
@@ -63,13 +64,16 @@
     inline WeaponManager& getWeaponManagerSecondary() { return this->secWeaponMan; };
 
-    //Functions for GUI
-    inline float getShieldCur() { return this->shieldCur; };        //!< returns current shield value
-    inline float getShieldMax() { return this->shieldMax; };        //!< returns maximum shield value
-
-    inline float getArmorCur() { return this->armorCur; };          //!< returns current armor value
-    inline float getArmorMax() { return this->armorMax; };          //!< returns current armor value
-
-    inline float getElectronicCur() { return this->electronicCur; }; //!< returns current electronic value
-    inline float getElectronicMax() { return this->electronicMax; }; //!< returns current electronic value
+    //!< functions for XML loading
+    void loadReactor(float output) {this->reactorOutput = output; };
+    void loadEngine( float speedBase) {this->engineSpeedBase = speedBase; };
+    void loadEnergyShare(float shield, float weapon, float engine)
+        { float tmp = shield + weapon + engine; if (unlikely (tmp > 1)) { tmp = 1/tmp; }
+          // HACK dirty safety hack, prevents total share being bigger than 1!!
+          this->shieldEnergyShare = shield * tmp;
+          this->weaponEnergyShare = weapon * tmp;
+          this->engineEnergyShare = engine * tmp; };
+    inline void loadWeapon(float regen) { this->weaponEnergyRegen = regen; };
+
+    void addWeaponToSlot(int wm, int config, int slot, const std::string& weaponName);
 
     inline PNode* getTravelNode() { return this->travelNode; };
@@ -86,5 +90,5 @@
     virtual void movement (float dt);
 
-    //
+
 
     void nextWeaponConfig();
@@ -92,5 +96,5 @@
 
     virtual void hit(float damage, WorldEntity* killer);
-    
+
     void                  setCameraDistance(float dist);
 
@@ -100,12 +104,12 @@
     //void calculateVelocity(float time);
 
-    void regen(float time);  //!< handler for shield and electronic regeneration
+//    void regen(float time);  //!< handler for shield and electronic regeneration
 
     void weaponRegen(float time);   //!< weapon energy regeneration
 
-    inline bool systemFailure() {  return (this->electronicCur < float(rand())/float(RAND_MAX) * this->electronicTH); };
-
-    void updateElectronicWidget();
-    void updateShieldWidget();
+//     inline bool systemFailure() {  return (this->getElectronic() < float(rand())/float(RAND_MAX) * this->getElectronicTH()); };
+
+//     void updateElectronicWidget();
+//     void updateShieldWidget();
 
     //WeaponManager         weaponMan;      //!< the primary weapon manager: managing a list of energy weapons to wepaon-slot mapping
@@ -115,22 +119,21 @@
 
     //ship atributes
-    float       shieldCur;          //!< current shield
-    float       shieldMax;          //!< maximum shield
-    float       shieldEnergyShare;  //!< percentage of reactor output
-    float       shieldRegen;        //!< shield regeneration rate per second
-    float       shieldTH;           //!< shield threshhold for reactivation
-    bool        shieldActive;       //!< wheather the shield is working
-    OrxGui::GLGuiEnergyWidgetVertical* shieldWidget; //!< holds the widget that shows the shield bar
-
-    float       armorCur;           //!< current armor
-    float       armorMax;           //!< maximum armor
-    float       armorRegen;         //!< armor regeneration per tick (usable on bioships?)
+//    float       shieldCur;          //!< current shield
+//    float       shieldMax;          //!< maximum shield
+//    float       shieldRegen;        //!< shield regeneration rate per second
+//    float       shieldTH;           //!< shield threshhold for reactivation
+//    bool        shieldActive;       //!< wheather the shield is working
+//    OrxGui::GLGuiEnergyWidgetVertical* shieldWidget; //!< holds the widget that shows the shield bar
+
+//    float       armorCur;           //!< current armor
+//    float       armorMax;           //!< maximum armor
+//    float       armorRegen;         //!< armor regeneration per tick (usable on bioships?)
     //note that the armor widget is set on the health- widget in world- entity (see in player.cc)
 
-    float       electronicCur;      //!< current electronic
-    float       electronicMax;      //!< maximum electronic
-    float       electronicRegen;    //!< electronic regenration rate per tick
-    float       electronicTH;       //!< Threshhold for electronic failure
-    OrxGui::GLGuiEnergyWidgetVertical* electronicWidget; //!< holds the widget that shows the electronic bar
+//    float       electronicCur;      //!< current electronic
+//    float       electronicMax;      //!< maximum electronic
+//    float       electronicRegen;    //!< electronic regenration rate per tick
+//    float       electronicTH;       //!< Threshhold for electronic failure
+//    OrxGui::GLGuiEnergyWidgetVertical* electronicWidget; //!< holds the widget that shows the electronic bar
 
     float       engineSpeedCur;     //!< speed output for movement = speed base + energy share part
@@ -138,4 +141,5 @@
     int         enginePowerConsume; //!< energy needed
     float       engineEnergyShare;  //!< percentage of reactor output
+    float       shieldEnergyShare;  //!< percentage of reactor output
 
     int         weaponEnergySlot;   //!< number of energy weapon slots
@@ -147,11 +151,11 @@
 
     float       reactorOutput;      //!< reactor output 
-    float       reactorCapacity;    //!< reactor capacity
+//    float       reactorCapacity;    //!< reactor capacity
 
     int         curWeaponPrimary;   //!< current primary weapon config 
     int         curWeaponSecondary; //!< current secondary weapon config
 
-    bool                  bForward;                //!< up button pressed.
-    bool                  bBackward;              //!< down button pressed.
+    bool                  bForward;           //!< up button pressed.
+    bool                  bBackward;          //!< down button pressed.
     bool                  bLeft;              //!< left button pressed.
     bool                  bRight;             //!< right button pressed.
@@ -161,4 +165,6 @@
     bool                  bRollR;             //!< rolling button pressed (right)
     bool                  bSecFire;           //!< second fire button pressed
+
+    bool                  bInit;              //!< set true, if MP have been loaded
 
     /*
@@ -208,9 +214,9 @@
 
     byte                  oldMask;            //!< used for synchronisation
-
+/*
     Trail*                trail;              //!< Burst trail
     Trail*                trailL;              //!< Burst trail
     Trail*                trailR;              //!< Burst trail
-
+*/
 
 };
Index: trunk/src/world_entities/spectator.cc
===================================================================
--- trunk/src/world_entities/spectator.cc	(revision 10697)
+++ trunk/src/world_entities/spectator.cc	(revision 10698)
@@ -28,4 +28,6 @@
 
 #include "player.h"
+
+#include "util/track/action_box.h"
 
 
@@ -300,4 +302,15 @@
   else if( event.type == KeyMapper::PEV_BACKWARD)
     this->bBackward = event.bPressed; //this->shiftCoor(0,-.1,0);
+  else if ( event.type == KeyMapper::PEV_JUMP )
+  {
+    if ( State::getActionBox() && State::getActionBox()->isPointInBox( this->getAbsCoor() ) )
+    {
+      PRINTF(0)("IN BOX\n");
+    }
+    else
+    {
+      PRINTF(0)("NOT IN BOX\n");
+    }
+  }
   else if( event.type == EV_MOUSE_MOTION)
   {
Index: trunk/src/world_entities/tools/camera.cc
===================================================================
--- trunk/src/world_entities/tools/camera.cc	(revision 10697)
+++ trunk/src/world_entities/tools/camera.cc	(revision 10698)
@@ -203,4 +203,20 @@
       this->setRelCoor(Vector(-0.05, this->viewTopDistance , 0));
       this->target->setRelCoor(0,0,0);
+      break;
+    }
+    case Camera::ViewFPS:
+    {
+      this->fovy = viewNormalFovy;
+      this->toFovy = viewNormalFovy;
+      this->setRelCoorSoft(this->viewFrontDistance, 0, 0, 5);
+      this->target->setRelCoorSoft(Vector(10,0,0), 5);
+      break;
+    }
+    case Camera::ViewFPSZoom:
+    {
+      this->fovy = viewNormalFovy;
+      this->toFovy = 30;
+      this->setRelCoorSoft(2, 0, 0, 5);
+      this->target->setRelCoorSoft(Vector(10,0,0), 5);
     }
   }
Index: trunk/src/world_entities/tools/camera.h
===================================================================
--- trunk/src/world_entities/tools/camera.h	(revision 10697)
+++ trunk/src/world_entities/tools/camera.h	(revision 10698)
@@ -34,5 +34,7 @@
     ViewLeft,
     ViewRight,
-    ViewTop
+    ViewTop,
+    ViewFPS,
+    ViewFPSZoom
   };
   public:
Index: trunk/src/world_entities/tools/mount_point.cc
===================================================================
--- trunk/src/world_entities/tools/mount_point.cc	(revision 10697)
+++ trunk/src/world_entities/tools/mount_point.cc	(revision 10698)
@@ -22,4 +22,5 @@
 
 #include "weapons/weapon_slot.h"
+#include "weapons/weapon.h"
 
 #include "particles/particle_system.h"
@@ -36,5 +37,5 @@
  * construct
  */
-MountPoint::MountPoint (const Vector& up, const Vector& forward, const Vector& center, const std::string& name)
+MountPoint::MountPoint (const Vector& up, const Vector& forward, const Vector& center,  const std::string& name)
 {
 //   PRINTF(0)("Created mount point %s\n", name.c_str());
@@ -153,4 +154,5 @@
                                     this->getRelDir()*Quaternion(M_PI, Vector(0,1,0)));
     }
+
   }
 }
Index: trunk/src/world_entities/weapons/aiming_system.cc
===================================================================
--- trunk/src/world_entities/weapons/aiming_system.cc	(revision 10697)
+++ trunk/src/world_entities/weapons/aiming_system.cc	(revision 10698)
@@ -112,5 +112,5 @@
 void AimingSystem::hit(float damage, WorldEntity* killer)
 {
-  if( this->owner != killer)
+  if( this->owner != killer && killer != this && !killer->isA( AimingSystem::staticClassID() ) )
   {
     //PRINTF(0)("real hit: %s\n", killer->getClassCName());
@@ -127,6 +127,4 @@
 void AimingSystem::tick(float dt)
 {
-
-
 }
 
Index: trunk/src/world_entities/weapons/bsp_weapon.cc
===================================================================
--- trunk/src/world_entities/weapons/bsp_weapon.cc	(revision 10698)
+++ trunk/src/world_entities/weapons/bsp_weapon.cc	(revision 10698)
@@ -0,0 +1,317 @@
+/*
+* orxonox - the future of 3D-vertical-scrollers
+*
+* Copyright (C) 2004 orx
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2, or (at your option)
+* any later version.
+*
+*     ### File Specific:
+*     main-programmer: Reto Luechinger
+*/
+
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+#include "bsp_weapon.h"
+#include "loading/load_param.h"
+#include "debug.h"
+#include "loading/load_param_xml.h"
+
+#include "environments/bsp_entity.h"
+#include "loading/fast_factory.h"
+
+ObjectListDefinition(BspWeapon);
+CREATE_FACTORY(BspWeapon);
+
+ObjectListDefinition(MuzzleFlash);
+
+/**
+*  Standard constructor
+*/
+BspWeapon::BspWeapon ()
+{
+	this->init();
+}
+
+/**
+* destructs the BspWeapon, deletes allocated memory
+*/
+BspWeapon::~BspWeapon ()
+{
+          // will be deleted
+}
+
+/**
+* Constructor with XML Element
+*/
+BspWeapon::BspWeapon (const  TiXmlElement* root)
+{
+	this->init();
+	if (root != NULL)
+        {
+		this->loadParams(root);
+	}
+}
+/**
+* XML Loader
+*/
+void BspWeapon::loadParams(const TiXmlElement* root)
+{
+	if (root != NULL)
+	{
+		WorldEntity::loadParams(root);
+
+		LoadParam(root, "Range", this, BspWeapon, setRange)
+			.describe("the range after which the Weapon hits no more")
+		.defaultValues("");
+                LoadParam(root, "Damage", this, BspWeapon, setDamage)
+                        .describe("Damage that the weapon inflicts"); 
+		LoadParam(root, "FireRate", this, BspWeapon, setFireRate)
+			.describe("how fast it shoots");
+		LoadParam(root, "AlwaysHits", this, BspWeapon, setAlwaysHits)
+			.describe("No, if the weapon should hit with a probability");
+
+		LOAD_PARAM_START_CYCLE(root, element);
+		{
+			if (root != 0){
+				LoadParam_CYCLE(element, "addPoint", this, BspWeapon, addPoint)
+				.describe("Adds a new Point for Gunfire");
+			}
+		}
+		LOAD_PARAM_END_CYCLE(element);
+	}
+}
+
+void BspWeapon::addPoint(float x, float y, float z)
+{
+  gunFire.push_back( new MuzzleFlash() );
+	gunFire.back()->setParent( this->getParent() );
+	gunFire.back()->setRelCoor(x, y, z);
+}
+
+void BspWeapon::tick( float dt )
+{
+	if (bFire) {
+		if (bRate < 0) {
+			bRate += fireRate;
+			this->shoot();
+		}
+		else {
+			bRate = bRate - dt;
+		}	
+	}
+	else {
+		bRate -= dt;
+		if (bRate < 0)
+			bRate = 0;
+	}
+
+}
+
+void BspWeapon::init()
+{
+	bRate = 0;
+	bFire = false;
+	range = 1000;
+	damage = 10;
+	fireRate = 0.5;
+	alwaysHits = true;
+
+	this->registerObject(this, BspWeapon::_objectList);
+	this->aimingSystem = new AimingSystem( this );
+	this->aimingSystem->setParent( this );
+	this->aimingSystem->toList(OM_GROUP_00);
+	
+}
+
+void BspWeapon::shoot()
+{
+	//gunFirExpl.explode(gunFire1,Vector(2,2,2));
+	//gunFirExpl.explode(gunFire2,Vector(2,2,2));
+
+  for ( std::list<MuzzleFlash*>::iterator it = gunFire.begin(); it!=gunFire.end(); it++)
+	{
+    (*it)->explode( 0.2 );
+	}
+
+	std::list<WorldEntity*>::iterator entityIterator;
+	// for all bsp managers check all entities
+	Vector pos = this->getAbsCoor();
+	Vector dir = pos + this->getAbsDir().apply( Vector( 1, 0, 0 ) )*range;
+	
+	
+	float shortestDist = range;
+	for( ObjectList<BspEntity>::const_iterator bspIterator = BspEntity::objectList().begin();
+		bspIterator != BspEntity::objectList().end();
+		bspIterator++) {
+		float res = (dynamic_cast<BspEntity*>(*bspIterator)->getBspManager())->checkCollisionRay( pos, dir, dir.len() + 1 );
+	
+		if ( res < shortestDist )
+			shortestDist = res;
+	}
+
+	WorldEntity* target = aimingSystem->getNearestTarget();
+	aimingSystem->flushList();
+
+	bool hit = false;
+
+	if ( target == NULL )
+		printf("NO TARGET\n");
+	else
+	{
+		if (!alwaysHits){
+			float r = rand();
+			r = r/RAND_MAX;
+			float res = (target->getAbsCoor() - this->getAbsCoor()).len();
+			float p = 1 - res*res/range/range;
+			if (r < p ){
+				hit = true;
+				printf( "HIT %s\n", target->getClassName().c_str() );
+			}
+			else
+				printf( "MISHIT %s\n", target->getClassName().c_str() );
+			
+		}
+		else hit = true;
+	}
+
+	if ( !hit )
+	{
+		//Vector explosionPos = this->getAbsCoor() + this->getAbsDir().apply( Vector( 1, 0, 0 ) )*shortestDist;
+
+		//TODO create explosion at explosionPos
+	}
+	
+	
+}
+
+void BspWeapon::draw() const
+{
+  WorldEntity::draw();
+
+  for ( std::list<MuzzleFlash*>::const_iterator it = gunFire.begin(); it!=gunFire.end(); it++)
+  {
+    (*it)->draw();
+  }
+#if 0
+  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
+
+  glPushAttrib(GL_ENABLE_BIT);
+
+  glDisable(GL_LIGHTING);
+  glDisable(GL_TEXTURE_2D);
+  glDisable(GL_BLEND);
+  glLineWidth(2.0);
+
+
+  Vector mp = this->getAbsCoor();
+  Vector op = this->getAbsDir().apply( Vector(1, 0, 0) );
+  op *= 100;
+  op += mp;
+
+  glColor3f(1.0, 1.0, 1.0 );
+  glBegin(GL_LINE_STRIP);
+    glVertex3f(mp.x, mp.y, mp.z);
+    glVertex3f(op.x, op.y, op.z);
+  glEnd();
+
+  
+  glPopAttrib();
+  glPopMatrix();
+#endif
+}
+
+void MuzzleFlash::draw( ) const
+{
+  if (explosionParticles) explosionParticles->draw();
+}
+
+void MuzzleFlash::activate()
+{
+	if (unlikely(explosionParticles == NULL))
+	{
+		explosionParticles = new SpriteParticles(5000);
+		explosionParticles->setName("MuzzleFlashExplosionParticles");
+		explosionParticles->setMaterialTexture("textures/radial-trans-noise.png");
+		explosionParticles->setLifeSpan(0.1, 0);
+		explosionParticles->setRadius(0.0, 8);
+		explosionParticles->setRadius(.5, 6.0);
+		explosionParticles->setRadius(1.0, 2.0);
+		explosionParticles->setColor(0.0, 1,0.7,0,1);
+		explosionParticles->setColor(0.4, 0.8,.5,0,1);
+		explosionParticles->setColor(0.8, 0.5,0,0,.8);
+		explosionParticles->setColor(1.0, 0,0,0,.6);
+    explosionParticles->toList(OM_DEAD_TICK);
+  }
+			
+	this->emitter->setSystem(explosionParticles);
+	this->emitter->updateNode(.01);
+	this->emitter->updateNode(.01);
+	this->toList(OM_DEAD_TICK);
+	this->lifeCycle = 0.0;
+}
+
+void MuzzleFlash::explode(float lifetime)
+{
+	MuzzleFlash* explosion = this;
+	//explosion->setAbsCoor(this->getAbsCoor());
+	explosion->emitter->setSize(1, 1, 1);
+	explosion->activate();
+	explosion->lifeTime = lifetime;
+}
+
+MuzzleFlash::MuzzleFlash ()
+{
+  this->explosionParticles = NULL;
+  this->registerObject(this, MuzzleFlash::_objectList);
+  this->toList(OM_DEAD_TICK);
+
+  this->emitter = new BoxEmitter(Vector(10,10,10), 200, 45, M_2_PI);
+  this->emitter->addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT);
+  this->emitter->setParent(this);
+  this->emitter->setSpread(M_PI, M_PI);
+
+  this->lifeCycle = 0.0f;
+  this->lifeTime = .5f;
+
+}
+
+
+/**
+ *  standard deconstructor
+*/
+MuzzleFlash::~MuzzleFlash ()
+{
+  delete this->emitter;
+
+  /* this is normaly done by World.cc by deleting the ParticleEngine */
+  if (explosionParticles != NULL)
+  {
+    delete explosionParticles;
+    MuzzleFlash::explosionParticles = NULL;
+  }
+}
+
+void MuzzleFlash::deactivate()
+{
+  this->emitter->setSystem(NULL);
+  this->toList(OM_DEAD);
+}
+
+
+/**
+ *  signal tick, time dependent things will be handled here
+ * @param time since last tick
+*/
+void MuzzleFlash::tick (float dt)
+{
+  this->lifeCycle += dt;
+  if(this->lifeTime < this->lifeCycle)
+    this->deactivate();
+}
+
+
+
Index: trunk/src/world_entities/weapons/bsp_weapon.h
===================================================================
--- trunk/src/world_entities/weapons/bsp_weapon.h	(revision 10698)
+++ trunk/src/world_entities/weapons/bsp_weapon.h	(revision 10698)
@@ -0,0 +1,85 @@
+/*
+* file bsp_weapon.h
+* A weapon that shoots both at player and environment (pnode and bsp).
+*/
+
+#ifndef _BSP_WEAPON_H
+#define _BSP_WEAPON_H
+
+#include "world_entity.h"
+#include "aiming_system.h"
+#include "effects/explosion.h"
+
+#include <list>
+
+#include "particles/box_emitter.h"
+#include "particles/sprite_particles.h"
+
+class MuzzleFlash : public WorldEntity
+{
+  ObjectListDeclaration(MuzzleFlash);
+  public:
+    void explode (float lifetime);
+
+    MuzzleFlash ();
+    virtual ~MuzzleFlash ();
+
+    virtual void activate();
+    virtual void deactivate();
+
+    virtual void tick (float time);
+    virtual void draw() const;
+
+    void setLifeTime( float lifeTime ){ this->lifeTime = lifeTime; }
+    
+    void drawParticles(){ if (explosionParticles) explosionParticles->draw(); }
+
+  protected:
+    //static FastFactory*        fastFactory;
+
+    float                      lifeTime;
+    float                      lifeCycle;
+
+    SpriteParticles*    explosionParticles;
+    BoxEmitter*                emitter;
+
+};
+
+
+class BspWeapon : public WorldEntity
+	{
+		ObjectListDeclaration(BspWeapon);
+	public:
+		BspWeapon ();
+		BspWeapon (const  TiXmlElement* root);
+		virtual ~BspWeapon();
+
+		void init();
+		void loadParams(const TiXmlElement* root);
+		void fire(bool fire){ bFire = fire; }
+		virtual void tick(float dt);
+		virtual void draw() const;
+
+
+	private:
+
+		void shoot();
+		float range;
+		void setRange( float r ){ this->range = r; }
+		float damage;
+		void setDamage( float d ){ this->damage = d; }
+		float fireRate;
+		void setFireRate( float r ){ this->fireRate = r; }
+		bool alwaysHits;
+		void setAlwaysHits( bool r ){ this->alwaysHits = r; }
+		void addPoint(float x, float y, float z);
+		
+    std::list<MuzzleFlash*> gunFire;
+
+		float bRate;
+		bool bFire;
+
+		AimingSystem* aimingSystem;
+	};
+
+#endif
Index: trunk/src/world_entities/weapons/disruptor.cc
===================================================================
--- trunk/src/world_entities/weapons/disruptor.cc	(revision 10698)
+++ trunk/src/world_entities/weapons/disruptor.cc	(revision 10698)
@@ -0,0 +1,227 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004-2006 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer: Marc Schaerrer, Nicolas Schlumberger
+   co-programmer:
+
+*/
+
+#include "disruptor.h"
+#include "world_entities/projectiles/projectile.h"
+
+#include "world_entity.h"
+#include "static_model.h"
+#include "weapon_manager.h"
+#include "util/loading/factory.h"
+
+#include "animation3d.h"
+
+#include "loading/fast_factory.h"
+
+#include "elements/glgui_energywidgetvertical.h"
+
+ObjectListDefinition(Disruptor);
+CREATE_FACTORY(Disruptor);
+
+/**
+ * Standard constructor
+ */
+Disruptor::Disruptor ()
+ : Weapon()
+{
+//     this->registerObject(this, Disruptor::_objectList);
+
+    this->init();
+}
+
+Disruptor::Disruptor (const TiXmlElement* root = NULL)
+ : Weapon()
+{
+//     this->registerObject(this, Disruptor::_objectList);
+
+    // TODO add leftRight to params
+    this->init();
+    if (root != NULL)
+      this->loadParams(root);
+}
+
+/**
+ * Default destructor
+ */
+Disruptor::~Disruptor()
+{
+  for (int i = 0; i < this->getBarrels(); i++)
+  {
+   delete [] this->shootAnim[i];
+   delete [] this->objComp[i];
+  }
+  delete [] this->emissionPoint;
+
+   delete [] this->shootAnim;
+   delete [] this->objComp;
+/*
+    for(int j = 0; j < this->getSegs(); j++)
+    {
+      delete this->shootAnim[i][j];
+      delete this->objComp[i][j];
+    }
+    delete this->shootAnim[i];
+    delete this->objComp[i];
+    delete this->emissionPoint[i];
+  }*/
+
+//  this->deconstr();
+     // model will be deleted from WorldEntity-destructor
+}
+
+void Disruptor::loadParams(const TiXmlElement* root)
+{
+  Weapon::loadParams(root);
+}
+
+void Disruptor::init()
+{
+
+  this->setScaling(.5);
+
+  this->loadModel("models/guns/disruptor.obj", this->getScaling());
+
+
+  this->setStateDuration(WS_SHOOTING, 0.3333);  // 3 Shots per Second
+  this->setStateDuration(WS_RELOADING, 0);
+  this->setStateDuration(WS_ACTIVATING, .5);
+  this->setStateDuration(WS_DEACTIVATING, 1);
+
+  this->setEnergyMax(500);
+  this->increaseEnergy(500);
+  //this->minCharge = 2;
+
+  this->setActionSound(WA_SHOOT, "sounds/guns/laser.wav");
+//   this->setActionSound(WA_ACTIVATE, "sounds/voices/lasers.wav");
+  this->setActionSound(WA_RELOAD, "sounds/spawn/alien_generator.wav");
+
+  this->setCapability(WTYPE_ALLDIRS | WTYPE_DIRECTIONAL | WTYPE_LIGHT);
+  this->setProjectileTypeC("HBolt");
+  this->prepareProjectiles(10);
+
+  this->setBarrels(1);
+  this->setSegs(1);
+  this->activeBarrel = 0;
+
+
+
+  this->objComp = new PNode**[this->getBarrels()];
+  this->emissionPoint = new PNode*[this->getBarrels()];
+  this->shootAnim = new Animation3D**[this->getBarrels()];
+  for (int i = 0; i < this->getBarrels(); i++)
+  {
+    this->objComp[i] = new PNode* [this->getSegs()];
+    this->emissionPoint[i] = new PNode;
+    this->emissionPoint[i]->setParent(this);  //Parenting emissionPoint to Weapon
+    this->emissionPoint[i]->setName("EmissionPoint");
+    this->emissionPoint[i]->addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT);
+    this->shootAnim[i] = new Animation3D* [this->getSegs()];
+    for(int j = 0; j < this->getSegs(); j++)
+    {
+      this->objComp[i][j] = new PNode;
+      this->shootAnim[i][j] = new Animation3D(this->objComp[i][j]);
+      this->shootAnim[i][j]->setInfinity(ANIM_INF_CONSTANT);
+    }
+  }
+
+  this->emissionPoint[0]->setRelCoor(Vector(1.672, 0.0, 0.0) * this->getScaling());
+
+
+  this->shootAnim[0][0]->addKeyFrame(Vector(0.0, 0.0, 0.0) * this->getScaling(), Quaternion(), 0.1, ANIM_LINEAR, ANIM_NULL);
+  this->shootAnim[0][0]->addKeyFrame(Vector(-0.5, 0.0, 0.0) * this->getScaling(), Quaternion(), 0.2, ANIM_LINEAR, ANIM_NULL);
+//   this->shootAnim[0][0]->addKeyFrame(Vector(0.0, 0.0, 0.0) * this->getScaling(), Quaternion(), 0.1, ANIM_LINEAR, ANIM_NULL);
+
+  Animation3D* animation2 = this->getAnimation(WS_ACTIVATING, this);
+  Animation3D* animation3 = this->getAnimation(WS_DEACTIVATING, this);
+
+  animation2->setInfinity(ANIM_INF_CONSTANT);
+  animation3->setInfinity(ANIM_INF_CONSTANT);
+
+  animation2->addKeyFrame(Vector(0.0, -1.0, 0.0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_NULL);
+  animation2->addKeyFrame(Vector(0.0, 0.0, 0.0), Quaternion(), 0.5, ANIM_LINEAR, ANIM_NULL);
+
+  animation3->addKeyFrame(Vector(0.0, 0.0, 0.0), Quaternion(), 0.5, ANIM_LINEAR, ANIM_NULL);
+  animation3->addKeyFrame(Vector(0.0, -1.0, 0.0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_NULL);
+}
+
+
+void Disruptor::fire()
+{
+  Projectile* pj =  this->getProjectile();
+  if (pj == NULL)
+    return;
+
+  // set the owner
+  pj->setOwner(this->getOwner());
+  pj->setParent(PNode::getNullParent());
+
+  pj->setVelocity(this->getAbsDir().apply(Vector(1,0,0))*130 + VECTOR_RAND(1));
+
+  pj->setAbsCoor(this->emissionPoint[this->activeBarrel]->getAbsCoor());
+  pj->setAbsDir(this->getAbsDir());
+  pj->activate();
+
+
+  this->shootAnim[0][0]->replay();
+
+
+}
+
+/**
+ *  this activates the weapon
+*/
+void Disruptor::activate()
+{
+}
+
+/**
+ *  this deactivates the weapon
+*/
+void Disruptor::deactivate()
+{
+}
+
+
+void Disruptor::draw() const
+{
+  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
+  glTranslatef (this->getAbsCoor ().x,
+                this->getAbsCoor ().y,
+                this->getAbsCoor ().z);
+    Vector tmpRot = this->getAbsDir().getSpacialAxis();
+    glRotatef (this->getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
+
+  //Base
+  static_cast<StaticModel*>(this->getModel())->draw(1);
+
+  // Barrel  glPushMatrix();
+  glTranslatef 
+    (this->objComp[0][0]->getAbsCoor().x, this->objComp[0][0]->getAbsCoor().y, this->objComp[0][0]->getAbsCoor().z);
+    static_cast<StaticModel*>(this->getModel())->draw(0);
+  glPopMatrix();
+}
+
+void Disruptor::tick(float dt)
+{
+  if (!Weapon::tickW(dt))
+    return;
+  if (this->energyWidget != NULL && !this->isEnergyWidgetInitialized)
+  {
+    this->energyWidget->setDisplayedImage("textures/gui/gui_heavy_bolt.png");
+    this->setEnergyWidgetInitialized(true);
+  }
+}
Index: trunk/src/world_entities/weapons/disruptor.h
===================================================================
--- trunk/src/world_entities/weapons/disruptor.h	(revision 10698)
+++ trunk/src/world_entities/weapons/disruptor.h	(revision 10698)
@@ -0,0 +1,45 @@
+#ifndef DISRUPTOR_H
+#define DISRUPTOR_H
+
+
+#include "weapon.h"
+
+// #define    W_LEFT        0
+// #define    W_RIGHT       1
+
+/**
+ *	@author Marc Schaerer <marcscha@ee.ethz.ch>
+ *
+ *  Heavy Blaster class
+ */
+class Disruptor : public Weapon
+{
+  ObjectListDeclaration(Disruptor);
+  public:
+    Disruptor();
+    Disruptor (const TiXmlElement* root);
+    virtual ~Disruptor();
+
+    void init();
+    virtual void loadParams(const TiXmlElement* root);
+
+    virtual void activate();
+    virtual void deactivate();
+
+    virtual void fire();
+
+    virtual void tick(float dt);
+
+    virtual void draw() const;
+
+  private:
+    PNode*** objComp;
+    Animation3D*** shootAnim;
+    PNode** emissionPoint;
+
+    int activeBarrel;
+
+//     int leftRight;
+};
+
+#endif
Index: trunk/src/world_entities/weapons/heavy_blaster.cc
===================================================================
--- trunk/src/world_entities/weapons/heavy_blaster.cc	(revision 10697)
+++ trunk/src/world_entities/weapons/heavy_blaster.cc	(revision 10698)
@@ -98,5 +98,5 @@
 //  this->model = (Model*)ResourceManager::getInstance()->load("models/guns/test_gun.obj", OBJ, RP_CAMPAIGN);
 
-  this->loadModel("models/guns/frag_cannon.obj", .4);
+  this->loadModel("models/guns/frag_cannon2.obj", .4);
 
 
@@ -131,5 +131,5 @@
     this->objComp[i] = new PNode* [this->getSegs()];
     this->emissionPoint[i] = new PNode;
-    this->emissionPoint[i]->setParent(this);             //< One EmissionPoint, that is a PNode connected to the weapon. You can set this to the exitting point of the Projectiles
+    this->emissionPoint[i]->setParent(this);      //Parenting emissionPoint to Weapons
     this->emissionPoint[i]->setName("EmissionPoint");
     this->emissionPoint[i]->addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT);
@@ -156,27 +156,12 @@
 
 
-//   Animation3D* animB0Shoot = this->getAnimation(WS_SHOOTING0, this->objComp[0][0]);
-//   Animation3D* animB1Shoot = this->getAnimation(WS_SHOOTING1, this->objComp2);
-//   Animation3D* animB2Shoot = this->getAnimation(WS_SHOOTING2, this->objComp3);
-//   Animation3D* animT0Shoot = this->getAnimation(WS_SHOOTING3, this->objComp[0][1]);
-//   Animation3D* animT1Shoot = this->getAnimation(WS_SHOOTING4, this->objComp5);
-//   Animation3D* animT2Shoot = this->getAnimation(WS_SHOOTING5, this->objComp6);
-
-
-//   this->shootAnim[0][0]->setInfinity(ANIM_INF_CONSTANT);
-//   animB1Shoot->setInfinity(ANIM_INF_CONSTANT);
-//   animB2Shoot->setInfinity(ANIM_INF_CONSTANT);
-//   animT0Shoot->setInfinity(ANIM_INF_CONSTANT);
-//   animT1Shoot->setInfinity(ANIM_INF_CONSTANT);
-//   animT2Shoot->setInfinity(ANIM_INF_CONSTANT);
-
   for (int i = 0; i < this->getBarrels(); i++){
-    this->shootAnim[i][0]->addKeyFrame(Vector(0.0, 0.0, 0.0), Quaternion(), 0.05, ANIM_LINEAR, ANIM_NULL);
+    this->shootAnim[i][0]->addKeyFrame(Vector(0.0, 0.0, 0.0), Quaternion(), 0.01, ANIM_LINEAR, ANIM_NULL);
     this->shootAnim[i][0]->addKeyFrame(Vector(-0.3, 0.0, 0.0), Quaternion(), 0.9, ANIM_LINEAR, ANIM_NULL);
-    this->shootAnim[i][0]->addKeyFrame(Vector(0.0, 0.0, 0.0), Quaternion(), 0.55, ANIM_LINEAR, ANIM_NULL);
-
-    this->shootAnim[i][1]->addKeyFrame(Vector(0.0, 0.0, 0.0), Quaternion(), 0.05, ANIM_LINEAR, ANIM_NULL);
+    this->shootAnim[i][0]->addKeyFrame(Vector(0.0, 0.0, 0.0), Quaternion(), 0.5, ANIM_LINEAR, ANIM_NULL);
+
+    this->shootAnim[i][1]->addKeyFrame(Vector(0.0, 0.0, 0.0), Quaternion(), 0.1, ANIM_LINEAR, ANIM_NULL);
     this->shootAnim[i][1]->addKeyFrame(Vector(-0.4, 0.0, 0.0), Quaternion(), 1.2, ANIM_LINEAR, ANIM_NULL);
-    this->shootAnim[i][1]->addKeyFrame(Vector(0.0, 0.0, 0.0), Quaternion(), 0.25, ANIM_LINEAR, ANIM_NULL);
+    this->shootAnim[i][1]->addKeyFrame(Vector(0.0, 0.0, 0.0), Quaternion(), 0.2, ANIM_LINEAR, ANIM_NULL);
   }
 
@@ -186,6 +171,4 @@
   animation2->setInfinity(ANIM_INF_CONSTANT);
   animation3->setInfinity(ANIM_INF_CONSTANT);
-
-//   this->setEmissionPoint(3.8, 1.2, 0, 0);
 
   animation2->addKeyFrame(Vector(0.0, -1.0, 0.0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_NULL);
@@ -207,12 +190,8 @@
   pj->setParent(PNode::getNullParent());
 
-//   pj->setVelocity(this->getAbsDir().apply(Vector(1,0,0))*250 + VECTOR_RAND(5));
-//   pj->setVelocity(this->getAbsDir().apply(Vector(1,0,0))*130 + VECTOR_RAND(1));
   pj->setVelocity(this->getAbsDir().apply(Vector(1,0,0))*130 + VECTOR_RAND(1));
 
   pj->setAbsCoor(this->emissionPoint[this->activeBarrel]->getAbsCoor());
-//   pj->setAbsCoor(this->getEmissionPoint(0));
   pj->setAbsDir(this->getAbsDir());
-//   pj->toList(OM_GROUP_01_PROJ);
   pj->activate();
 
